import webiopi
import datetime
#from webiopi.devices.sensor import TMP102
# Enable debug output
webiopi.setDebug()

#tmp = TMP102()

GPIO = webiopi.GPIO
LIGHT = 17 # GPIO pin using BCM numbering
MOTOR_DRIVER_1	=  13 # STEP Motor Diver Line GPIO13 PWM1
MOTOR_DRIVER_2	=  18 # GPIO19 PWM3
MOTOR_DRIVER_3	=  19 # GPIO19 PWM2
MOTOR_DRIVER_4	=  12 # GPIO12 PWM4

HOUR_ON  = 8  # Turn Light ON at 08:00
HOUR_OFF = 18 # Turn Light OFF at 18:00

PULSE_RATION = 0.5
PULSE_ANGLE = 10

tick  = 0
# setup function is automatically called at WebIOPi startup
def setup():
    # set the GPIO used by the light to output
    GPIO.setFunction(LIGHT, GPIO.OUT)
    #
    GPIO.setFunction(MOTOR_DRIVER_1, GPIO.OUT)
    GPIO.setFunction(MOTOR_DRIVER_2, GPIO.OUT)
    GPIO.setFunction(MOTOR_DRIVER_3, GPIO.OUT)
    GPIO.setFunction(MOTOR_DRIVER_4, GPIO.OUT)
	
    # retrieve current datetime
    now = datetime.datetime.now()

    #celsius = tmp.getCelsius()
    #print("tick = ", celsius)
	
    GPIO.setFunction(8, GPIO.PWM)
    GPIO.pwmWrite(8, 0.5)        # set to 50% ratio

    # test if we are between ON time and tun the light ON
    if ((now.hour >= HOUR_ON) and (now.hour < HOUR_OFF)):
        GPIO.digitalWrite(LIGHT, GPIO.HIGH)



# loop function is repeatedly called by WebIOPi 
def loop():
    # retrieve current datetime
    now = datetime.datetime.now()
    global HOUR_ON, PULSE_RATION, PULSE_ANGLE
    # toggle light ON all days at the correct time
    if ((now.hour == HOUR_ON) and (now.minute == 0) and (now.second == 0)):
        if (GPIO.digitalRead(LIGHT) == GPIO.LOW):
            GPIO.digitalWrite(LIGHT, GPIO.HIGH)

    # toggle light OFF
    if ((now.hour == HOUR_OFF) and (now.minute == 0) and (now.second == 0)):
        if (GPIO.digitalRead(LIGHT) == GPIO.HIGH):
            GPIO.digitalWrite(LIGHT, GPIO.LOW)
			
   # 创建一个变量不断切换四个端口的高低电平，保证任何状态只有
   # 一个端口出于高电平实现四组同占空比不同角度输出PWM
    global tick
    if tick == 3:
       tick = 0
    else:
       tick += 1
	   
    print("tick = ", tick)
    print("LOOP HOUR_ON = ",HOUR_ON)
    
    if tick == 0:
      GPIO.digitalWrite(MOTOR_DRIVER_1, GPIO.HIGH)
      GPIO.digitalWrite(MOTOR_DRIVER_2, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_3, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_4, GPIO.LOW)
    elif tick == 1:
      GPIO.digitalWrite(MOTOR_DRIVER_1, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_2, GPIO.HIGH)
      GPIO.digitalWrite(MOTOR_DRIVER_3, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_4, GPIO.LOW)
    elif tick == 2:
      GPIO.digitalWrite(MOTOR_DRIVER_1, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_2, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_3, GPIO.HIGH)
      GPIO.digitalWrite(MOTOR_DRIVER_4, GPIO.LOW)
    else:
      GPIO.digitalWrite(MOTOR_DRIVER_1, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_2, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_3, GPIO.LOW)
      GPIO.digitalWrite(MOTOR_DRIVER_4, GPIO.HIGH)
	  
    # gives CPU some time before looping again
    webiopi.sleep(0.1 * HOUR_ON)

# destroy function is called at WebIOPi shutdown
def destroy():
    GPIO.digitalWrite(LIGHT, GPIO.LOW)
    GPIO.digitalWrite(MOTOR_DRIVER_1, GPIO.LOW)
    GPIO.digitalWrite(MOTOR_DRIVER_2, GPIO.LOW)
    GPIO.digitalWrite(MOTOR_DRIVER_3, GPIO.LOW)
    GPIO.digitalWrite(MOTOR_DRIVER_4, GPIO.LOW)

@webiopi.macro
def getLightHours():
    print("Get HOUR_ON = ",HOUR_ON)
    return "%d;%d" % (HOUR_ON, HOUR_OFF)

@webiopi.macro
def setLightHours(on, off):
    global HOUR_ON, HOUR_OFF
    print("Set HOUR_ON = ",HOUR_ON)
    HOUR_ON = int(on)
    HOUR_OFF = int(off)
    return getLightHours()