#   Copyright 2012-2013 Eric Ptak - trouch.com
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

from webiopi.utils.types import toint, signInteger
from webiopi.devices.i2c import I2C
from webiopi.devices.sensor import Temperation



class LMT84(I2C, Temperation):
	def __init__(self, slave=0x48):
		I2C.__init__(self, toint(slave))
	
	def __str__(self):
		return "LMT84(slave=0x%02X)" % self.slavey
		
	def __getCelsius__(self):
		d0 = self.readRegisters(0x0 , 2)
		count = ((d0[0] << 4) | (d0[1] >> 4)) & 0xFFFF
		return signInteger(count, 13)

