#   Copyright 2012-2013 Eric Ptak - trouch.com
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

from webiopi.utils.types import toint, signInteger
from webiopi.devices.i2c import I2C
from webiopi.devices.sensor import Luminosity



class OPT3001(I2C, Luminosity):
	def __init__(self, slave=0x44):
		I2C.__init__(self, toint(slave))
		config = [0xc4, 0x10]
		self.writeRegisters(0x01,config) 
	
	def __str__(self):
		return "OPT3001(slave=0x%02X)" % self.slave
		
	def __getLux__(self):
		d0 = self.readRegisters(0x00 , 2)
		count = ((d0[0] << 4) | (d0[1] >> 4)) & 0xFFFF
		return count
